package de.howaner.MapEditor.gui;

import de.howaner.MapEditor.MainMapEditor;
import de.howaner.MapEditor.map.MapTerrain;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JTextField;

public class MapPropertiesDialog extends JDialog {
	private JTextField joinMessageField;
	private JButton saveButton;
	private JButton closeButton;

	public MapPropertiesDialog(MyWindow window) {
		super(window, "Map Properties");
		this.getContentPane().setLayout(new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS));
		this.setSize(400, 80);
		this.setResizable(false);

		this.addComponents();
	}

	private void addComponents() {
		this.joinMessageField = new JTextField();

		this.getContentPane().add(this.createHorizontalBox("Betreten Nachricht: ", this.joinMessageField));

		Box buttonBox = Box.createHorizontalBox();
		buttonBox.add(Box.createHorizontalGlue());
		buttonBox.add(this.closeButton = new JButton("Schließen"));
		buttonBox.add(this.saveButton = new JButton("Speichern"));
		this.getContentPane().add(buttonBox);

		this.loadProperties();
		this.addListeners();
	}

	public void loadProperties() {
		MapTerrain map = MainMapEditor.instance.getLoadedMap();
		this.joinMessageField.setText(map.getJoinMessage());
	}

	private void addListeners() {
		this.saveButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				MapTerrain map = MainMapEditor.instance.getLoadedMap();

				String newJoinMessage = MapPropertiesDialog.this.joinMessageField.getText();

				map.setJoinMessage(newJoinMessage);
				MapPropertiesDialog.this.setVisible(false);
			}
		});

		this.closeButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				MapPropertiesDialog.this.setVisible(false);
			}
		});
	}

	public Box createHorizontalBox(String name, JTextField field) {
		Box box = Box.createHorizontalBox();
		box.add(new JLabel(name));
		box.add(Box.createHorizontalGlue());
		box.add(field);
		return box;
	}

}
