package de.howaner.MapEditor.gui.components;

import de.howaner.MapEditor.MainMapEditor;
import de.howaner.MapEditor.map.events.EventType;
import java.awt.Component;
import java.awt.image.BufferedImage;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class GuiEventTypesList extends JList implements ListSelectionListener {

	public GuiEventTypesList() {
		super();

		this.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		this.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		this.setVisibleRowCount(-1);
		this.setCellRenderer(new TilesetIconRenderer());
		this.addListSelectionListener(this);

		this.loadModel();
	}

	public void loadModel() {
		DefaultListModel model = new DefaultListModel();

		for (int i = 0; i < EventType.values().length; i++) {
			model.addElement("");
		}

		this.setModel(model);
	}

	@Override
	public void valueChanged(ListSelectionEvent event) {
		MainMapEditor.instance.getWindow().updateSelectedEventTypeName();
	}

	public class TilesetIconRenderer extends DefaultListCellRenderer {
		@Override
		public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
			EventType eventType = EventType.getFromId(index);
			BufferedImage image = eventType.getImage();
			Icon icon = new ImageIcon(image);

			JLabel label = (JLabel) super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
			label.setIcon(icon);
			return label;
		}
	}

}
