package de.howaner.MapEditor.gui.components;

import de.howaner.MapEditor.map.MapWalkData;
import java.awt.Component;
import java.awt.image.BufferedImage;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListSelectionModel;

public class GuiWalkDataList extends JList {

	public GuiWalkDataList() {
		super();

		this.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		this.setLayoutOrientation(JList.HORIZONTAL_WRAP);
		this.setVisibleRowCount(-1);
		this.setCellRenderer(new TilesetIconRenderer());

		this.loadModel();
	}

	public void loadModel() {
		DefaultListModel model = new DefaultListModel();
		
		for (int i = 0; i < MapWalkData.WalkDataType.values().length; i++) {
			model.addElement("");
		}

		this.setModel(model);
	}

	public class TilesetIconRenderer extends DefaultListCellRenderer {
		@Override
		public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
			MapWalkData.WalkDataType walkData = MapWalkData.WalkDataType.getFromId(index);
			BufferedImage image = walkData.getImage();
			Icon icon = new ImageIcon(image);

			JLabel label = (JLabel) super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
			label.setIcon(icon);
			return label;
		}
	}

}
