package de.howaner.MapEditor.map.events;

import de.howaner.MapEditor.map.MapTerrain;
import de.howaner.Pokemon.saveformat.TagCompound;
import java.awt.Component;
import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JTextField;

public class EventEntity extends Event {
	private String textureName = "";
	private String scriptName = "";

	public EventEntity(MapTerrain map, int posX, int posY) {
		super(map, posX, posY);
	}

	public String getTextureName() {
		return this.textureName;
	}

	public void setTextureName(String textureName) {
		this.textureName = textureName;
	}

	public String getScriptName() {
		return this.scriptName;
	}

	public void setScriptName(String scriptName) {
		this.scriptName = scriptName;
	}

	@Override
	public void loadFromCompound(TagCompound compound) {
		super.loadFromCompound(compound);
		this.textureName = compound.getString("TextureName");
		this.scriptName = compound.getString("ScriptName");
	}

	@Override
	public void saveToCompound(TagCompound compound) {
		super.saveToCompound(compound);
		compound.setString("TextureName", this.textureName);
		compound.setString("ScriptName", this.scriptName);
	}

	@Override
	public void addGuiComponents(Box box) {
		box.add(this.createHorizontalBox("Texture Name: ", new JTextField(), this.textureName));
		box.add(this.createHorizontalBox("Skript Name: ", new JTextField(), this.scriptName));
	}

	@Override
	public void readFromGuiComponents(Box box) {
		Box textureNameBox = (Box) box.getComponent(box.getComponentCount() - 3);
		this.textureName = ((JTextField) textureNameBox.getComponent(2)).getText();

		Box scriptNameBox = (Box) box.getComponent(box.getComponentCount() - 2);
		this.scriptName = ((JTextField) scriptNameBox.getComponent(2)).getText();
	}

	@Override
	public EventType getType() {
		return EventType.ENTITY;
	}

	private Box createHorizontalBox(String name, Component field, String defaultText) {
		if (defaultText != null && field instanceof JTextField)
			((JTextField)field).setText(defaultText);

		Box box = Box.createHorizontalBox();
		box.add(new JLabel(name));
		box.add(Box.createHorizontalGlue());
		box.add(field);
		return box;
	}

}
