package de.howaner.MapEditor.map.events;

import de.howaner.MapEditor.map.MapTerrain;
import de.howaner.Pokemon.saveformat.TagCompound;
import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JTextField;

public class EventScript extends Event {
	private String scriptName = "";

	public EventScript(MapTerrain map, int posX, int posY) {
		super(map, posX, posY);
	}

	public String getScriptName() {
		return this.scriptName;
	}

	public void setScriptName(String scriptName) {
		this.scriptName = scriptName;
	}

	@Override
	public void loadFromCompound(TagCompound compound) {
		super.loadFromCompound(compound);
		this.scriptName = compound.getString("ScriptName");
	}

	@Override
	public void saveToCompound(TagCompound compound) {
		super.saveToCompound(compound);
		compound.setString("ScriptName", this.scriptName);
	}

	@Override
	public void addGuiComponents(Box box) {
		JTextField field = new JTextField();
		field.setText(this.scriptName);

		Box myBox = Box.createHorizontalBox();
		myBox.add(new JLabel("Skript Name: "));
		myBox.add(Box.createHorizontalGlue());
		myBox.add(field);

		box.add(myBox);
	}

	@Override
	public void readFromGuiComponents(Box box) {
		Box myBox = (Box) box.getComponent(box.getComponentCount() - 2);
		JTextField field = (JTextField) myBox.getComponent(2);

		this.scriptName = field.getText();
	}

	@Override
	public EventType getType() {
		return EventType.SCRIPT;
	}

}
