package de.howaner.Pokemon.saveformat;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

public class TagByteArray extends TagBase {
	private byte[] data;

	public TagByteArray() {
		this(new byte[0]);
	}

	public TagByteArray(byte[] data) {
		this.data = data;
	}

	public byte[] getData() {
		return this.data;
	}

	@Override
	public void read(DataInput input) throws IOException {
		int length = input.readInt();
		this.data = new byte[length];

		for (int i = 0; i < length; i++) {
			this.data[i] = input.readByte();
		}
	}

	@Override
	public void write(DataOutput output) throws IOException {
		output.writeInt(this.data.length);

		for (byte b : this.data) {
			output.writeByte(b);
		}
	}

}
