package de.howaner.Pokemon.saveformat;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class TagList extends TagBase {
	private int tagType;
	private List<TagBase> data;

	public TagList() {
		this(0, new ArrayList<TagBase>());
	}

	public TagList(int tagType, List<TagBase> data) {
		this.tagType = tagType;
		this.data = data;
	}

	public List<TagBase> getData() {
		return this.data;
	}

	public int getTagType() {
		return this.tagType;
	}

	@Override
	public void read(DataInput input) throws IOException {
		// Read type:
		this.tagType = input.readByte();
		if (this.tagType <= 0 || this.tagType >= TagCompound.tagTypes.length) {
			// Invalid type
			return;
		}
		Class<?> tagClass = TagCompound.tagTypes[this.tagType];

		int length = input.readInt();
		for (int i = 0; i < length; i++) {
			TagBase tag = null;
			try {
				tag = (TagBase) tagClass.newInstance();
			} catch (Exception e) { }

			tag.read(input);
			this.data.add(tag);
		}
	}

	@Override
	public void write(DataOutput output) throws IOException {
		output.writeByte(this.tagType);
		output.writeInt(this.data.size());

		for (TagBase tag : this.data) {
			tag.write(output);
		}
	}

}
